ghc-7.8.4: The GHC API

Safe Haskell | None
Language | Haskell98

SimplUtils

# Documentation

mkLam :: [OutBndr] -> OutExpr -> SimplCont -> SimplM OutExpr

mkCase :: DynFlags -> OutExpr -> OutId -> OutType -> [OutAlt] -> SimplM OutExpr

prepareAlts :: OutExpr -> OutId -> [InAlt] -> SimplM ([AltCon], [InAlt])

tryEtaExpandRhs :: SimplEnv -> OutId -> OutExpr -> SimplM (Arity, OutExpr)

preInlineUnconditionally :: DynFlags -> SimplEnv -> TopLevelFlag -> InId -> InExpr -> Bool

postInlineUnconditionally :: DynFlags -> SimplEnv -> TopLevelFlag -> OutId -> OccInfo -> OutExpr -> Unfolding -> Bool

activeUnfolding :: SimplEnv -> Id -> Bool

activeRule :: SimplEnv -> Activation -> Bool

getUnfoldingInRuleMatch :: SimplEnv -> InScopeEnv

simplEnvForGHCi :: DynFlags -> SimplEnv

updModeForInlineRules :: Activation -> SimplifierMode -> SimplifierMode

data SimplCont

Constructors

Stop OutType CallCtxt |
CoerceIt OutCoercion SimplCont |
ApplyTo DupFlag InExpr StaticEnv SimplCont |
Select DupFlag InId [InAlt] StaticEnv SimplCont |
StrictBind InId [InBndr] InExpr StaticEnv SimplCont |
StrictArg ArgInfo CallCtxt SimplCont |
TickIt (Tickish Id) SimplCont |

Instances

Outputable SimplCont |

data DupFlag

Constructors

NoDup |
Simplified |
OkToDup |

Instances

Outputable DupFlag |

isSimplified :: DupFlag -> Bool

contIsDupable :: SimplCont -> Bool

contResultType :: SimplCont -> OutType

contInputType :: SimplCont -> OutType

contIsTrivial :: SimplCont -> Bool

contArgs :: SimplCont -> (Bool, [ArgSummary], SimplCont)

dropArgs :: Int -> SimplCont -> SimplCont

pushSimplifiedArgs :: SimplEnv -> [CoreExpr] -> SimplCont -> SimplCont

countValArgs :: SimplCont -> Int

countArgs :: SimplCont -> Int

mkBoringStop :: OutType -> SimplCont

mkRhsStop :: OutType -> SimplCont

mkLazyArgStop :: OutType -> CallCtxt -> SimplCont

contIsRhsOrArg :: SimplCont -> Bool

interestingCallContext :: SimplCont -> CallCtxt

interestingArg :: CoreExpr -> ArgSummary

data ArgInfo

Constructors

ArgInfo |

Fields

ai_fun :: OutId
ai_args :: [ArgSpec]
ai_type :: OutType
ai_rules :: [CoreRule]
ai_encl :: Bool
ai_strs :: [Bool]
ai_discs :: [Int]

data ArgSpec

Constructors

ValArg OutExpr |
CastBy OutCoercion |

Instances

Outputable ArgSpec |

mkArgInfo :: Id -> [CoreRule] -> Int -> SimplCont -> ArgInfo

addArgTo :: ArgInfo -> OutExpr -> ArgInfo

addCastTo :: ArgInfo -> OutCoercion -> ArgInfo

argInfoExpr :: OutId -> [ArgSpec] -> OutExpr

argInfoValArgs :: SimplEnv -> [ArgSpec] -> SimplCont -> ([OutExpr], SimplCont)

abstractFloats :: [OutTyVar] -> SimplEnv -> OutExpr -> SimplM ([OutBind], OutExpr)